/*
 * Copyright (c) 1998-2001 by Winfried Bruns and Robert Koch
 */
 
Int traf (Int **oldgen, int m, int *dim, Int **invtraf, Int **invtraflf, Int **newgen, int emb, Int **a)
{
	int n=*dim, ne=n, nz=n, en=m, zn=m+n, dn=m+2*n;
	int d, i, j, k, mn, r, s;
	Int idx, vol;
	
	idx = 1;
	vol = 1;
	mn = min (m, n);
	for (i=1; i<=en; ++i)
		for (j=1; j<=ne; ++j)
			a[i][j] = oldgen[i][j];
	for (i=m+1; i<=m+n; ++i)
	{
		for (j=1; j<=n; ++j)
			a[i][j] = a[i+n][j] = 0;
		a[i][i-m] = a[i+n][i-m] = 1;
	}
	for (d=0; d<mn; ++d)
	{
		locpiv (a, en, ne, &r, &s);
		if (r)
		{
			do
			{
				chgrow (a, en, nz, r);		// lege "Pivotzeile" gemaess Fortschritt
				chgcol (a, ne, dn, s);		// auf die unterste Position
				redrow (a, ne, nz, en);
				redcol (a, ne, en, zn, dn);
				locpiv (a, en, ne, &r, &s);
			}
			while (r < en || s < ne);
			--ne;
			--en;
		}
		else
			break;
	}				// d = rk A

	for (i=1; i<=m; ++i)										// find newgen
		for (j=1; j<=d; ++j)
		{
			newgen[i][j] = 0;
			for (k=1; k<=n; ++k)
				newgen[i][j] += oldgen[i][k] * a[k+m][n-d+j];
			if (emb)
			{
				newgen[i][j] /= a[m-d+j][n-d+j];
			}
		}

	for (j=1; j<=d; ++j)
	{
		idx *= a[m-d+j][n-d+j];
	}
	for (i=1; i<=n; ++i)									// find invtraf (inverse der 1. "Untermatrix")
		for (j=1; j<=d; ++j)
		{
			if (emb)										// multipliziere mit den Diagonaleintraegen
				invtraf[j][i] = a[i+m+n][n-d+j] * a[m-d+j][n-d+j];
			else
				invtraf[j][i] = a[i+m+n][n-d+j];
		}

	for (j=1; j<=d; ++j)									// find invtraflf
		vol *= Labs (a[m-d+j][n-d+j]);
	for (j=1; j<=d; ++j)
		for (i=1; i<=n; ++i)
		{
			if (emb)
				invtraflf[j][i] = a[i+m][n-d+j] * (vol / a[m-d+j][n-d+j]);
			else
				invtraflf[j][i] = a[i+m][n-d+j];
		}
		
	*dim = d;										// n = olddim,  d = newdim
	return (Labs (idx));
}

void retraf (il **newgen, Int **invtraf, int inv_en, int inv_ne, il **oldgen)
{
	multlist (newgen, invtraf, inv_en, inv_ne, oldgen);		
}

void retraflf (il **newsup, Int **invtraflf, int inv_en, int inv_ne, il **oldsup, int emb)
{
	multlist (newsup, invtraflf, inv_en, inv_ne, oldsup);		
}

/*
** Locates the minimal (absolute value taken) element != 0 in the upper submatrix of A.
** Pivot stored in 'invisible' array element a[0][0].
** Position of pivot stored in (r,s).
*/
void locpiv (Int **a, int m, int n, int *r, int *s)
{
	int i, j;
	
	*r = *s = 0;
	for (i=m; i>0; --i)
	{
		for (j=n; j>0; --j)
			if (a[i][j] != 0)
			{
				a[0][0] = Labs (a[*r=i][*s=j]);	// abs function for type long; here first declare *r=i, *s=j
				break;
			}
		if (*r)
			break;
	}

	if (*r)
	{
		for (--j; j>0; --j)
			if (a[i][j] != 0  &&  Labs (a[i][j]) < a[0][0])
				a[0][0] = Labs (a[i][*s=j]);
		for (--i; i>0; --i)
			for (j=n; j>0; --j)
				if (a[i][j] != 0  &&  Labs (a[i][j]) < a[0][0])
					a[0][0] = Labs (a[*r=i][*s=j]);
	}
}

/*
** Swap r-th row of a with en-th row
** (Why do we need nz here? Isn't used...)
*/
void chgrow (Int **a, int en, int nz, int r)
{
	Int *dum;
	
	dum = a[r];
	a[r] = a[en];
	a[en] = dum;
}

void Chgrow (Int **a, Int **b, int en, int nz, int r)
{
	Int *dum;
	
	dum = a[r];
	a[r] = a[en];
	a[en] = dum;
	dum = b[r];
	b[r] = b[en];
	b[en] = dum;
}

void chgcol (Int **a, int ne, int dn, int s)
{
	int i;
	
	for (i=1; i<=dn; ++i)
	{
		a[0][0] = a[i][s];
		a[i][s] = a[i][ne];
		a[i][ne] = a[0][0];
	}
}

/*
** reduces a COLUMN row-by-row
*/
void redrow (Int **a, int ne, int nz, int en)
{
	int i, j;
	
	for (i=1; i<en; ++i)
	{
		if ((a[0][0] = a[i][ne] / a[en][ne]) != 0)
			for (j=1; j<=nz; ++j)
				a[i][j] -= a[0][0] * a[en][j];
	}
}

void Redrow (Int **a, Int **b, int ne, int nz, int en)
{
	int i, j;
	
	for (i=1; i<en; ++i)
	{
		if ((a[0][0] = a[i][ne] / a[en][ne]) != 0)
			for (j=1; j<=nz; ++j)
			{
				a[i][j] -= a[0][0] * a[en][j];
				b[i][j] -= a[0][0] * b[en][j];
			}
	}
}

void redcol (Int **a, int ne, int en, int zn, int dn)
{
	int i, j;
	
	for (j=1; j<ne; ++j)
	{
		if ((a[0][0] = a[en][j] / a[en][ne]) != 0)
		{
			for (i=1; i<=zn; ++i)
				a[i][j] -= a[0][0] * a[i][ne];
			for (; i<=dn; ++i)
				a[i][ne] += a[0][0] * a[i][j];
		}
	}
}

void multmat (Int **a, int aen, int ane, Int **b, int bne, Int **c)
{
	int i, j, k;
	
	for (i=1; i<=aen; ++i)
		for (j=1; j<=bne; ++j)
		{
			c[i][j] = 0;
			for (k=1; k<=ane; ++k)
				c[i][j] += a[i][k] * b[k][j];
		}
}

void multlist (il **a, Int **b, int ben, int bne, il **c)
{
	int i, j, k;
	il *dum, *null=NULL;
	
	for (dum=*a; dum; dum=dum->right)
	{
		iisert (c, &null, bne + 1);
		for (j=1; j<=bne; ++j)
		{
			(*c)->ind[j] = 0;
			for (k=1; k<=ben; ++k)
				(*c)->ind[j] += dum->ind[k] * b[k][j];
		}
	}
}

void multvmv (Int *a, int alen, Int **b, int blen, Int *c)
{
	int j, k;
	
	for (j=1; j<=blen; ++j)
	{
		c[j] = 0;
		for (k=1; k<=alen; ++k)
			c[j] += a[k] * b[k][j];
	}
}

void scalmult (Int scal, Int *vec, int len)
{
	int i;
	
	for (i=1; i<=len; ++i)
		vec[i] *= scal;
}

void scalmultmod (Int scal, Int *vec, Int mod, int len)
{
	int i;
	
	for (i=1; i<=len; ++i)
		vec[i] = (scal * vec[i]) % mod;
}

void scaldiv (Int scal, Int *vec, int len)
{
	int i;
	
	for (i=1; i<=len; ++i)
		vec[i] /= scal;
}

void addvecs (Int *a, Int *b, Int *c, int len)
{
	int i;
	
	for (i=1; i<=len; ++i)
		c[i] = a[i] + b[i];
}

void cpvec (Int *a, Int *b, int len)
{
	int i;
	
	for (i=1; i<=len; ++i)
		b[i] = a[i];
}

void redmod (Int *vec, Int d, int len)
{
	int i;
	
	for (i=1; i<=len; ++i)
		vec[i] %= d;
}
