int heap_ascending_build(pl **simp, int *offs, pl *pdum, int j)
{
  simp[++offs[0]] = pdum;
  offs[offs[0]] = j;
}

int hsets_encode(int **len, int **set, int **nxt, int *aloc, int *used, int *prefix, int i, pl *pdum, int j)
{  
  int *temp;
  int newaloc;

  if (*used == *aloc)
    {
      //      printf("Realocating.\n");
      newaloc = *aloc?2**aloc:1;
      //      printf("new size = %d\n", newaloc);
      
      if (*aloc)
	{
	  if (! (*len = (int *) realloc (*len, newaloc * sizeof (int))))
	    memerr ();
	  if (! (*set = (int *) realloc (*set, newaloc * sizeof (int))))
	    memerr ();
	  if (! (*nxt = (int *) realloc (*nxt, newaloc * sizeof (int))))
	    memerr ();
	}
      else
	{
	  if (! (*len = (int *) calloc (newaloc, sizeof (int))))
	    memerr ();
	  if (! (*set = (int *) calloc (newaloc, sizeof (int))))
	    memerr ();
	  if (! (*nxt = (int *) calloc (newaloc, sizeof (int))))
	    memerr ();
	}
      *aloc = newaloc;
      //      printf("Realocation complete.\n");

      //      printf("used = %d, len[0] = %d, nxt[0] = %d, set[0] = %d\n", *used, (*len)[0], (*nxt)[0], (*set)[0]);
    }
  --j;
  //  printf("about to fill len. used is %d. j is %d.\n", *used, j);
  (*len)[*used] = j;
  //  printf("Filling entry %d out of %d.\n", *used, *aloc);
  (*nxt)[*used] = pdum->hsets;
  //  printf("nxt done.\n");
  pdum->hsets = *used;
  //  printf("hsets done.\n");

  --i;
  //  printf("Encoding bits\n");
  for ((*set)[*used]=0; j; --j)
    {
      (*set)[*used] <<= 1;
      if (i>=0)
	{
	  if (pdum->ind[j] == prefix[i])
	    {
	      (*set)[*used] |= 1;
	      --i;
	    }
	}
    }
  //  printf("Bit encoding done: %d %d %d\n", (*len)[*used], (*set)[*used], (*nxt)[*used]);
  ++*used;
  //  printf("%d\n", *used);
}

int heap_compare(pl *pdum1, int j1, pl *pdum2, int j2)
{
  int i;
  int k;

  for(i=0; j1+i<=pdum1->len && j2+i<=pdum2->len; ++i)
    {
      k = pdum1->ind[j1+i]-pdum2->ind[j2+i];
      if (k)
	return(k);
    }
  return(pdum2->len-pdum1->len-j2+j1);
}

void heap_get(pl **simp, int *offs, pl **pdum, int *j1)
{
  *pdum = simp[1];
  *j1 = offs[1];
}

void heap_descending_build(pl **simp, int *offs, pl *pdum, int k, int i)
{
  int j;
  int l;

  //  printf("heap_descending_build called with: position %d of", k);
  //  for(j=1; j<=pdum->len; ++j)
  //    {
  //      printf(" %d", pdum->ind[j]);
  //    }
  //  printf("\n");
  
  for(; i; )
    {
      j=2*i;
      if (j < offs[0])
	{
	  if (heap_compare(simp[j], offs[j], simp[j + 1], offs[j + 1]) > 0)
	    {
	      ++j;
	    }
	}
      if (j <= offs[0])
	{
	  l = heap_compare(simp[j], offs[j], pdum, k);
	}
      else
	{
	  l = 0;
	}
      if (l < 0)
	{ 
	  simp[i] = simp[j];
	  offs[i] = offs[j];
	  i = j;
	}
      else
	{
	  simp[i] = pdum;
	  offs[i] = k;
      	  i=0;
	}
    }  
}

void heap_delete(pl **simp, int *offs)
{
  --offs[0];
  heap_descending_build(simp, offs, simp[offs[0]+1], offs[offs[0]+1], 1);
}

void heap_get_and_clean(pl **simp, int *offs, pl **pdum1, int *j1)
{
  int i1;
  int i2;
  int j2;
  int k;
  pl *pdum2;
  heap_get(simp, offs, pdum1, j1);

  //  printf("heap_get returned: position %d of", *j1);
  //  for(k=1; k<=(*pdum1)->len; ++k)
  //    {
  //      printf(" %d", (*pdum1)->ind[k]);
  //    }
  //  printf("\n");

  for (k=0; !k; )
    {
      if (!offs[0])
	{
	  k = 1;
	}
      else
	{
	  pdum2 = simp[1];
	  i1 = *j1;
          
	  for (i2=offs[1]; !k && i2<=pdum2->len; )
	    {
	      if (i1 > (*pdum1)->len)
		{
		  k = 1;
		}
	      else
		{
		  if ((*pdum1)->ind[i1] < pdum2->ind[i2])
		    {
		      ++i1;
		    }
		  else
		    {
		      k = (*pdum1)->ind[i1++]-pdum2->ind[i2++];
		    }
		}
	    }
	  if (!k)
	    {
	      heap_delete(simp, offs);
	    }
	}
    }
}

void heap_add(pl **simp, int *offs, pl *pdum, int j)
{
  int i;
  int k;
  i = ++offs[0];

  //  printf("heap_add called with: position %d of", j);
  //  for(k=1; k<=pdum->len; ++k)
  //    {
  //      printf(" %d", pdum->ind[k]);
  //    }
  //  printf("\n");
  
  for(k=1; k; )
    {
      //      printf("considering %d\n", i);
      if (i==1)
	{
	  k = 0;
	}
      else
	{
	  if (heap_compare(pdum, j, simp[i/2], offs[i/2]) < 0)
	    {
	      simp[i] = simp[i/2];
	      offs[i] = offs[i/2];
	      i /= 2;
	    }
	  else
	    {
	      k = 0;
	    }
	}
    }

  //  printf("landed at %d\n", i);

  simp[i] = pdum;
  offs[i] = j;
}

void heap_init_build(pl **simp, int *offs, int r)
{
  offs[0] = r;
}

void heap_clean(pl **simp, int *offs)
{
  heap_init_build(simp, offs, 0);
}
