/*
 * Copyright (c) 1998-2006 by Winfried Bruns and Robert Koch
 */

#include <sys/times.h> // wj {

long Cpu_time_counter(void)
{

  /* Function returns elapsed cpu_time (in: number of ticks) */
  struct tms tms;

  if (times(&tms) == -1) {
    fprintf(stderr, "'times' failed\n");
    exit(1);
  }
  return (tms.tms_utime + tms.tms_stime);
} // wj }

int main (int argc, char **argv)
{
   char *input, *output, *fname;
   int d=0, dim, olddim, mode, emb, flag, hom, i, j, k, l, m, nc, nsup, nv, prim, r, s; // wj {
   int copt, fopt, hopt, vopt, hits, genwid, supwid, valwid, numgen, numsup, numext;    // wj }
   int ii;
   int HilbPolyComp, length_ext, allfopt;  //wb
   Int idx, mty, lcm, primmult, vol;
   int *hvec, *insig, *ninsig, *zer, *hsets_nxt, *hsets_set, *hsets_prefix, *hsets_len;
   int **hmat, **heap_offs; // wj {}
   Int *evec, *hnum, *hden;
   Int **help1, **help2, **help3, **help4, **help5, **invtraflf, **invtraf, **oldgen, **newgen; // wj {}
   il  *idum=NULL, *iidum=NULL, *iiidum=NULL, *ifrei=NULL, *iifrei=NULL, *sol=NULL, *elimsol=NULL, *newsol=NULL, *sup=NULL, *newsup=NULL, *vals=NULL;
   il  *myptr, *hlist=NULL, *hreflist=NULL, *hfullreflist=NULL, *frhm=NULL;
   pl *newsig=NULL, *pdum=NULL, *pfrei=NULL, *sig=NULL; // wj {}
   FILE *fp;
   int bitc, blcnt, numbl, subblcnt=0, numsubbl, hsets_aloc, hsets_used; // wj {
   pl  *blptr, *blptr2, **blstart, **subbl, ***heap_simp;
   long lasttime,time,time1,time2;                                       // wj }

   #ifndef LONG_BIT
   LONG_BIT = cntone (~(0ul));
   #endif

   lasttime = Cpu_time_counter();// wj }
   time = time1 = time2 = 0;            // wj }


                                                      // check command
   copt = fopt = allfopt = hopt = vopt = hits = 0;
   if (argc < 2)
      cmderr ();
   for (i=1; i<argc; ++i)
      if (argv[i][0] == '-')
      {
         r = 1;
         while (argv[i][r] != '\0')
         {
            if (argv[i][r] == 'c')
               copt = 1;
            else if (argv[i][r] == 'f')
               fopt = 1;
            else if (argv[i][r] == 'h')
               hopt = 1;
            else if (argv[i][r] == 'v')
               vopt = 1;
            else if (argv[i][r] == 'a')
               { allfopt = 1; fopt=1;}
            else
               fprintf (stderr, "warning: unknown option `%c' \n", argv[i][r]);
            ++r;
         }
      }
      else
      {
         s = i;
         ++hits;
      }
   if (hits != 1)
      cmderr ();
   if (vopt && hopt)
   {
      hopt = 0;
      fprintf (stderr, "warning: ignoring option `h' due to `v' \n");
   }
   if (! (fname = (char *) calloc (strlen (argv[s]) + 1, sizeof (char))))
      memerr ();
   strcpy (fname, argv[s]);

                                                      // file name
   if (! (input = (char *) calloc (strlen (fname) + 5, sizeof (char))))
      memerr ();
   if (! (output = (char *) calloc (strlen (fname) + 5, sizeof (char))))
      memerr ();

                                            // read data
   strcpy (input, fname);
   strcat (input, ".in");
   ifstream from (input);
   if (! from)
      readerr ();
   if ((! (from >> nc)) || nc <= 0)
      dataerr ();
   if ((! (from >> dim)) || dim <= 0)
      dataerr ();

                                         // allocate memory
   if (! (blstart = (pl **) calloc (nc, sizeof (pl *))))
      memerr ();
   nc += dim;
   ++dim;
   if (! (invtraf = (Int **) calloc (dim+1, sizeof (Int *))))
      memerr ();
   if (! (invtraflf = (Int **) calloc (dim+1, sizeof (Int *))))
      memerr ();
   for (i=0; i<=dim; ++i)
   {
      if (! (invtraf[i] = (Int *) calloc (dim+1, sizeof (Int))))
         memerr ();
      if (! (invtraflf[i] = (Int *) calloc (dim+1, sizeof (Int))))
         memerr ();
   }

   if (! (evec = (Int *) calloc (dim+1, sizeof (Int))))
      memerr ();
   if (! (hnum = (Int *) calloc (dim+1, sizeof (Int))))
      memerr ();
   if (! (hden = (Int *) calloc (dim+1, sizeof (Int))))
      memerr ();
   if (! (hvec = (int *) calloc (dim+1, sizeof (int))))
      memerr ();
   if (! (insig = (int *) calloc (nc+1, sizeof (int))))
      memerr ();
   if (! (ninsig = (int *) calloc (nc+1, sizeof (int))))
      memerr ();
   if (! (zer = (int *) calloc (dim+nc+1, sizeof (int))))
      memerr ();
   if (! (hmat = (int **) calloc (dim+1, sizeof (int *))))
      memerr ();
   for (i=0; i<=dim; ++i)
   {
      evec[i] = hnum[i] = hden[i] = 0;
      if (! (hmat[i] = (int *) calloc (dim+1, sizeof (int))))
         memerr ();
   }
   if (! (oldgen = (Int **) calloc (nc+1, sizeof (Int *))))
      memerr ();
   if (! (newgen = (Int **) calloc (nc+1, sizeof (Int *))))
      memerr ();
   for (i=0; i<=nc; ++i)
   {
      if (! (oldgen[i] = (Int *) calloc (dim+1, sizeof (Int))))
         memerr ();
      if (! (newgen[i] = (Int *) calloc (dim+1, sizeof (Int))))
         memerr ();
   }

   k = nc+2*dim+1;
   if (! (help1 = (Int **) calloc (k, sizeof (Int *))))
      memerr ();
   if (! (help2 = (Int **) calloc (k, sizeof (Int *))))
      memerr ();
   if (! (help3 = (Int **) calloc (k, sizeof (Int *))))
      memerr ();
   if (! (help4 = (Int **) calloc (k, sizeof (Int *))))
      memerr ();
   for (i=0; i<k; ++i)
   {
      if (! (help1[i] = (Int *) calloc (dim+2, sizeof (Int))))
         memerr ();
      if (! (help2[i] = (Int *) calloc (dim+2, sizeof (Int))))
         memerr ();
      if (! (help3[i] = (Int *) calloc (dim+2, sizeof (Int))))
         memerr ();
      if (! (help4[i] = (Int *) calloc (dim+2, sizeof (Int))))
         memerr ();
      for (j=0; j<=dim+1; ++j)
         help1[i][j] = help2[i][j] = help3[i][j] = help4[i][j] = 0;
   }
   --dim;
   nc -= dim;

                                         // read vectors
   for (i=1; i<=nc; ++i)
      for (j=1; j<=dim; ++j)
         if (! (from >> oldgen[i][j]))
            dataerr ();
   if (! (from >> mode))
      dataerr ();
   from.close ();
   if (mode < 0   ||   mode > 3)
      moderr ();

                                  // polytopal or Rees application?
   emb = mode;
   prim = 0; // wj {}

   if (mode == 2)
   {
      ++dim;
      for (i=1; i<=nc; ++i)
         oldgen[i][dim] = 1;
      emb = 0;
   }
   else if (mode == 3)
   {

      for (i=nc; i>0; --i)
      {
         for (j=1; j<=dim; ++j)
       {
            oldgen[i+dim][j] = oldgen[i][j];
        help1[i][j] = 0; // wj {}
       }
         oldgen[i+dim][j] = 1;
         for (j=1; j<=dim && oldgen[i][j]==0; ++j); // wj {
         if (j<=dim)
         {
         for (k=j+1; k<=dim && oldgen[i][k]==0; ++k);
         if (k>dim)
           help1[i][j] = 1;
       } // wj }
      }


      prim = 1; // wj {
      for (j=1; j<=dim; ++j)
    {
      for (i=1; i<=nc && help1[i][j]==0; ++i);
      if (i>nc)
          prim = 0;
    } // wj}

      ++dim;
      for (i=1; i<dim; ++i)
      {
         for (j=1; j<=dim; ++j)
            oldgen[i][j] = 0;
         oldgen[i][i] = 1;
      }
      nc += dim - 1;
      emb = 0;
   }

                                    // find embedding
   olddim = dim;
   idx = traf (oldgen, nc, &dim, invtraf, invtraflf, newgen, emb, help1);

                                  // are newgen's homogeneous?
   for (i=1; i<=nc; ++i)
      for (j=1; j<=dim; ++j)
         help1[i][j] = newgen[i][j];
   hom = ishom (help1, nc, dim, help2, help3, newgen);
   if (hom)                                   // determine invtraf's
   {
      for (i=1; i<=dim; ++i)
         for (j=1; j<=olddim; ++j)
            help1[i][j] = invtraf[i][j];
      multmat (help2, dim, dim, help1, olddim, invtraf);
      for (i=1; i<=dim; ++i)
         for (j=1; j<=olddim; ++j)
            help1[i][j] = invtraflf[i][j];
      multmat (help3, dim, dim, help1, olddim, invtraflf);
   }

                                       // sigma's
                                       // support hyperplanes
   insig[0] = ninsig[0] = 0;
   for (i=1; i<=nc; ++i)
      ninsig[i] = nc + 1 - i;
   ninsig[0] = nc;
   setsig (blstart, &numbl, newgen, dim, &sig, insig, ninsig, &pfrei, help1);
   addsig (blstart, &numbl, newgen, nc, dim, &sup, &sig, insig, ninsig, &pfrei, help1, zer, copt);

   if (allfopt)                                   // wj {
   {
      strcpy (output, fname);
      strcat (output, ".tri");                    // to .tri
      ofstream ttto (output);
      if (! ttto)
         wrterr ();
      ttto << plength(sig) << "\n";
      ttto << dim+1 << "\n";
      for (pdum=sig; pdum; pdum=pdum->right)
    {
      for (i=1; i<=dim; ++i)
      {
        ttto << pdum->ind[i] << " ";
            for (j=1; j<=dim; ++j)
              help4[i][j] = newgen[pdum->ind[i]][j];
          }
          vol = divisors (help4, dim, help1, help2, &lcm);
          ttto << vol << "\n";
    }
      ttto.close ();
   } // wj }

   ctrlcone (&sup, help3, dim);

                                        // reduce newgen's
   shorten (newgen, nc, dim);
   for (i=1; i<=nc; ++i)
      reduce (&sol, newgen[i], dim, sup, &ifrei, help1[0], mode);

                                       // investigate sigmas
   bitc = 1 + (nc-1) / LONG_BIT;
   if (hom && hopt && (dim > LONG_BIT))
   {
      fprintf (stderr, "warning: not enough bits, ignoring option `h' \n");
      hopt = 0;
   }

   r = plength (sig);
   if (! (subbl = (pl **) calloc (r+1, sizeof (pl *))))
      memerr ();

   if (hom && hopt) // wj {
     {
       // initialize heaps and hsets
       if (! (heap_simp = (pl ***) calloc (dim + 1, sizeof (pl **))))
     memerr ();
       if (! (hsets_prefix = (int *) calloc (dim + 1, sizeof (int))))
     memerr ();
       if (! (heap_offs = (int **) calloc (dim + 1, sizeof (int *))))
     memerr ();
       for (i=0; i<=dim; ++i)
     {
       if (! (heap_simp[i] = (pl **) calloc (r+1, sizeof (pl *))))
         memerr ();
       if (! (heap_offs[i] = (int *) calloc (r+1, sizeof (int))))
         memerr ();
     }
       for (pdum=sig; pdum; pdum=pdum->right)
     {
       pdum->hsets = -1;
     }
       hsets_aloc = 0;
       hsets_used = 0;
       //       printf("init done\n");

       // build heap0
       heap_init_build(heap_simp[0], heap_offs[0], r);
       //       printf("heap 0 has %d items\n", heap_offs[0][0]);
       //       printf("heap 0 build initialized\n");
       i = r;
       for (pdum=sig; pdum; pdum=pdum->right)
     {
       pdum->len = dim;
       for (j=1; j<dim; )
         {
           if (pdum->ind[j] <= pdum->ind[j+1])
         {
           ++j;
         }
           else
         {
           k = pdum->ind[j];
           pdum->ind[j] = pdum->ind[j+1];
           pdum->ind[j+1] = k;
           if (j>1)
             {
               --j;
             }
         }
         }
       heap_descending_build(heap_simp[0], heap_offs[0], pdum, 1, i--);
     }
       //       printf("heap 0 built\n");
       //       printf("heap 0 has %d items\n", heap_offs[0][0]);

       // main loop
       for (i=0; i>=0; )
     {
       //      printf("heap %d has %d items\n", i, heap_offs[i][0]);
       if (!heap_offs[i][0])
         {
           --i;
         }
       else
         {
           heap_get_and_clean(heap_simp[i], heap_offs[i], &pdum, &j);
           //          printf("got from heap %d: position %d of", i, j);
           //          for(k=1; k<=pdum->len; ++k)
           //        {
           //          printf(" %d", pdum->ind[k]);
           //            }
           //          printf("\n");
           if (!heap_offs[i][0])
         {
           //          printf("encoding\n");
           hsets_encode(&hsets_len, &hsets_set, &hsets_nxt, &hsets_aloc, &hsets_used, hsets_prefix, i, pdum, j);
           //          printf("set %d nxt %d len %d\n", hsets_set[0], hsets_nxt[0], hsets_len[0]);
           --i;
         }
           else
         {
           heap_add(heap_simp[i], heap_offs[i], pdum, j+1);

           hsets_prefix[i] = pdum->ind[j];
               heap_clean(heap_simp[i+1], heap_offs[i+1]);
           heap_ascending_build(heap_simp[i+1], heap_offs[i+1], pdum, j+1);
           for (k=pdum->ind[j]; k; )
             {
               if (!heap_offs[i][0])
             {
               k = 0;
             }
               else
             {
               pdum = heap_simp[i][1];
               j = heap_offs[i][1];
               //              printf("peeking at heap %d: position %d of", i, j);
               //              for(l=1; l<=pdum->len; ++l)
               //                {
               //                  printf(" %d", pdum->ind[l]);
               //                }
               //              printf("\n");

               if (j > pdum->len)
                 {
                   k = 0;
                 }
               else
                 {
                   if (pdum->ind[j] > k)
                 {
                   k = 0;
                 }
                   else
                 {
                   heap_get_and_clean(heap_simp[i], heap_offs[i], &pdum, &j);
                   heap_add(heap_simp[i], heap_offs[i], pdum, j+1);
                   heap_ascending_build(heap_simp[i+1], heap_offs[i+1], pdum, j+1);
                 }
                 }
             }
             }
           ++i;
         }
         }
     }
       //       printf("main loop done\n");
     }              // wj }

   if (hom)
     {
       mty = 0;
       //       if (hopt)
       //    setup (&hreflist, &hfullreflist, hmat, hvec, &frhm, dim);
       // neu in [dim]
     }
   k = 0;


   newsig = NULL; // wj {}
   // ATTENTION: block #1 needs separate treatment
   for (blcnt=1; blcnt<=numbl; ++blcnt)
     {
       if (blstart[blcnt]->left)           // cut chain
         {
       blstart[blcnt]->left->right = NULL;
       blstart[blcnt]->left = NULL;
         }
       for (i=0; i<=r; ++i)
     subbl[i] = NULL;
       subblocks (&blstart[blcnt], subbl, &numsubbl, dim, insig, ninsig);
       for (subblcnt=1; subblcnt<=numsubbl; ++subblcnt)
         {
       k = 0;
       s = plength (subbl[subblcnt]);
       for (pdum=subbl[subblcnt]; pdum; pdum=pdum->right)
         {
               if (copt)
         fprintf (stdout, "[%d.%d] %d / %d\n", blcnt, subblcnt, ++k, s);
               for (i=1; i<=dim; ++i)
         for (j=1; j<=dim; ++j)
           help4[i][j] = newgen[pdum->ind[i]][j];
               vol = divisors (help4, dim, help1, help2, &lcm);// h1[0]=d-vec, h2=S'
               if (hom)
         {
           mty += vol;
           //          if (hopt)
           //            {
           //              time = Cpu_time_counter();// wj {
           //              time1 += (time - lasttime);
           //              lasttime = time;// wj }
           //
           //              if (! (pdum->bitv = (ul *) calloc (bitc, sizeof (ul))))
           //            memerr ();
           //              for (i=0; i<bitc; ++i)
           //            pdum->bitv[i] = 0;
           //              for (i=1; i<=dim; ++i)
           //            if (bitc == 1)
           //              *(pdum->bitv) |= (1ul << (pdum->ind[i]-1));
           //            else
           //              bitset (pdum->bitv, pdum->ind[i]-1);
           //              reset (&hlist, &hreflist, &hfullreflist);
           //
           //              mark (blcnt, subblcnt, &hreflist, &hfullreflist, &hlist, dim, bitc, subbl[subblcnt], pdum);
           //
           //              time = Cpu_time_counter();// wj {
           //              time2 += (time - lasttime);
           //              lasttime = time;// wj }
           //            }
         }
           //            printf(".\n");
           if (! vopt)
         points (help4, help3[0], help2, help1[0], help1[1], dim, lcm, &sol, sup, &ifrei, hlist, hmat, hom & hopt, mode, pdum->hsets, hsets_nxt, hsets_set, hsets_len);
           //            printf(",\n");
         }
       pdum = subbl[subblcnt]; // wj {
       pdum->left = NULL;
       if (pdum)
         {
           while (pdum->right)
         pdum = pdum->right;
           if (newsig)
         newsig->left = pdum;
           pdum->right = newsig;
           newsig = subbl[subblcnt];
         } // wj }
     }
     }
    HilbPolyComp=1;

#ifndef INTEGER
    if(dim>13) HilbPolyComp=0; // in normaliz dim <= 13 is necessary to
                               // avoid overflow in (dim-1)!
#endif

   if (hom & hopt)
     {
       sumhvec (hmat, hvec, dim);
       if(HilbPolyComp) hilbpoly (hvec, hnum, hden, evec, help1, dim);
     }

   // re-embed
   if (! vopt)
     retraf (&sol, invtraf, dim, olddim, &newsol);
   retraflf (&sup, invtraflf, dim, olddim, &newsup, emb);
   shorten (invtraflf, 1, olddim);
   shlist (newsup, olddim);

   if (prim) // wj {
     {
       primmult = 0;
       for (idum=newsup; idum; idum=idum->right)
     {
       for (pdum=newsig; pdum; pdum=pdum->right)
         {
           for (i=1; i<=dim; ++i)
         {
           j = 0;
           for (k=1; k<=dim; ++k)
             {
               if (k!=i && oldgen[pdum->ind[k]][dim]==1 && scprod(oldgen[pdum->ind[k]], idum->ind, olddim)==0)
             {
               ++j;
               for (m=1; m<dim; ++m)
                 help4[j][m] = oldgen[pdum->ind[k]][m];
             }
             }
           if (j+1==dim)
             primmult += divisors(help4, j, help1, help2, &lcm);
         }
         }
     }
     } // wj }


                                                 // print results
   numgen = ilength (sol);                       // wj {
   numsup = ilength (sup);
   if (allfopt)                                       // write "e" files
     {                                             // if they are useful
       if (! vopt && (emb || dim < olddim))
     {
       strcpy (output, fname);
           strcat (output, ".egn");                 // to .egn
           ofstream tto (output);
           if (! tto)
         wrterr ();
           tto << numgen << '\n';
           tto << dim << '\n';
           for (idum=sol; idum; idum=idum->right)
         {
           for (j=1; j<=dim; ++j)
         tto << idum->ind[j] << " ";
           tto << '\n';
         }
       tto.close ();

       strcpy (output, fname);
           strcat (output, ".esp");              // to .esp
       ofstream otto (output);
       if (! otto)
         wrterr ();
       otto << numsup << '\n';
       otto << dim << '\n';
       for (idum=sup; idum; idum=idum->right)
         {
           for (j=1; j<=dim; ++j)
         otto << idum->ind[j] << " ";
           otto << '\n';
         }
       otto.close ();

           strcpy (output, fname);
               strcat (output, ".evl");              // to .evl
           ofstream vtto (output);
           if (! vtto)
         wrterr ();
           vtto.setf (ios::right | ios::adjustfield);
           for (i=1; i<=numgen; ++i)
         iisert (&vals, &iifrei, numsup+1);
           idum = vals;
           for (iidum=sol; iidum; iidum=iidum->right)
         {
           j = 0;
           for (iiidum=sup; iiidum; iiidum=iiidum->right)
             {
               ++j;
               idum->ind[j] = scprod (iidum->ind, iiidum->ind, dim);
             }
           idum = idum->right;
         }
           valwid = 1 + maxoptlen (vals, numsup);
           vtto << numgen << '\n' << numsup << '\n';
           for (idum=vals; idum; idum=idum->right)
         {
           for (j=1; j<=numsup; ++j)
             {
                  // vtto.width (valwid);
               for (ii=0; ii<valwid-optlen(idum->ind[j]); ++ii)
             vtto << " ";
               vtto << idum->ind[j];
             }
           vtto << '\n';
         }
           vtto.close ();

     }
     }                                           // wj }

   numgen = ilength (newsol);
   numsup = ilength (newsup);
   if (fopt)
   {
      if (! vopt)
      {
         strcpy (output, fname);
         strcat (output, ".gen");                 // to .gen
         ofstream tto (output);
         if (! tto)
            wrterr ();
         tto << numgen << '\n';
         tto << olddim << '\n';
         for (idum=newsol; idum; idum=idum->right)
         {
            for (j=1; j<=olddim; ++j)
               tto << idum->ind[j] << " ";
            tto << '\n';
         }
         tto.close ();
      }
      if (dim == olddim)
      {
         strcpy (output, fname);
         strcat (output, ".sup");              // to .sup
         ofstream otto (output);
         if (! otto)
            wrterr ();
         otto << numsup << '\n';
         otto << olddim << '\n';
         for (idum=newsup; idum; idum=idum->right)
         {
            for (j=1; j<=olddim; ++j)
               otto << idum->ind[j] << " ";
            otto << '\n';
         }
         otto.close ();
         if (! vopt)
         {
            strcpy (output, fname);
            strcat (output, ".val");              // to .val
            ofstream vtto (output);
            if (! vtto)
               wrterr ();
            vtto.setf (ios::right | ios::adjustfield);
            for (i=1; i<=numgen; ++i)
               iisert (&vals, &iifrei, numsup+1);
            idum = vals;
            for (iidum=newsol; iidum; iidum=iidum->right)
            {
               j = 0;
               for (iiidum=newsup; iiidum; iiidum=iiidum->right)
               {
                  ++j;
                  idum->ind[j] = scprod (iidum->ind, iiidum->ind, olddim);
               }
               idum = idum->right;
            }
            valwid = 1 + maxoptlen (vals, numsup);
            vtto << numgen << '\n' << numsup << '\n';
            for (idum=vals; idum; idum=idum->right)
            {
               for (j=1; j<=numsup; ++j)
               {
                  // vtto.width (valwid);
                  for (ii=0; ii<valwid-optlen(idum->ind[j]); ++ii)
                     vtto << " ";
                  vtto << idum->ind[j];
               }
               vtto << '\n';
            }
            vtto.close ();
         }
      }
   }
   strcpy (output, fname);
   strcat (output, ".out");                    // to .out
   ofstream to (output);
   if (! to)
      wrterr ();
   to.setf (ios::right | ios::adjustfield);

   numext=0; // wj {
   if (!vopt)
     {
       if (! (help5 = (Int **) calloc (nc+1, sizeof (Int *))))
     memerr ();
       for (i=0; i<=nc; ++i)
     {
       if (! (help5[i] = (Int *) calloc (numsup+1, sizeof (Int))))
         memerr ();
         }
       for (i=1; i<=nc; ++i)
     {
           j=1;
           for (idum=newsup; idum; idum=idum->right)
             {
           if (oldgen[i][olddim]!=1 && mode==2)
         help5[i][j++] = 1;
           else
         help5[i][j++] = scprod(oldgen[i], idum->ind, olddim);
         }
     }
       do
     {
       l=0;
       for (i=1; i<=nc; ++i)
         {
           k=0;
           for (j=1; j<=numsup; j++)
         {
           if (help5[i][j] == 0)
             ++k;
         }
           if (k>l)
         {
           l=k;
           m=i;
         }
         }
       if (l)
         {
           for (i=1; i<=nc; ++i)
         {
           if (i!=m)
             {
               k=1;
               for (j=1; j<=numsup; j++)
             if (help5[i][j]==0 && help5[m][j]!=0)
               k = 0;
               if (k)
             {
               for (j=1; j<=numsup; j++)
                 help5[i][j] = 1;
             }
             }
         }
           ++numext;
           for (i=1; i<=olddim; ++i)
         help1[numext][i]=oldgen[m][i];
           for (j=1; j<=numsup; j++)
         help5[m][j] = 1;
         }
     }
       while (l);
     } // wj }

     if (allfopt && numext)   // to .ext
     {
        if(mode==2) length_ext=olddim-1;
        else length_ext=olddim;
        strcpy (output, fname);
        strcat (output, ".ext");
        ofstream otto (output);
        otto << numext << '\n';
        otto << length_ext << '\n';

        for (i=1; i<=numext; ++i)
        {
             for (j=1; j<=length_ext; ++j) otto << help1[i][j] << " ";
            otto << '\n';
        }
        otto.close ();
     }

                                             // standard case
   if (mode <= 1)
   {
      if (! vopt)
      {
         genwid = 2 + maxoptlen (newsol, olddim);
         to << ilength (newsol) << " generators of integral closure: \n";
         for (idum=newsol; idum; idum=idum->right)
         {
            for (j=1; j<=olddim; ++j)
            {
               // to.setf (ios::right | ios::adjustfield);
               // to.setf (ios::right);
               // to.unsetf (ios::skipws);
               // to.width (genwid);
               for (ii=0; ii<genwid-optlen(idum->ind[j]); ++ii)
                  to << " ";
               to << idum->ind[j];
            }
            to << '\n';
         }
         to << '\n';

         if (numext) {to << numext << " extreme rays: \n"; } // wj {
     for (i=1; i<=numext; ++i)
       {
         for (j=1; j<=olddim; ++j)
           {
         for (ii=0; ii<genwid-optlen(help1[i][j]); ++ii)
           to << ' ';
         to << help1[i][j];
           }
         to << '\n';
       }
     to << '\n'; // wj }
      }
      if (olddim == dim)
      {
         to << "(original) semigroup has rank " << dim << " (maximal) \n";
         if (! emb)
            to << "(original) semigroup is of index " << idx << '\n';
         to << '\n';
         i = 0;
         for (idum=newsup; idum; idum=idum->right)
            ++i;
         supwid = 2 + maxoptlen (newsup, olddim);
         to << i << " support hyperplanes: \n";
         for (idum=newsup; idum; idum=idum->right)
         {
            for (j=1; j<=olddim; ++j)
            {
               // to.width (supwid);
               for (ii=0; ii<supwid-optlen(idum->ind[j]); ++ii)
                  to << " ";
               to << idum->ind[j];
            }
            to << '\n';
         }
      }
      else
       {
         to << "(original) semigroup has rank " << dim << " (not maximal) \n";
         if (! emb)
            to << "(original) semigroup is of index " << idx << '\n';
       }
      to << '\n';
      if (hom)
      {
         to << "(original) semigroup is homogeneous via the linear form \n";
         for (j=1; j<=olddim; ++j)
            to << "   " << invtraflf[1][j];
         to << "\n\n";
         to << "multiplicity = " << mty << '\n';
         if (hopt)
         {
            to << '\n' << "h-vector =";
            for (i=0; i<dim; ++i)
               to << "   " << hvec[i];
           if(HilbPolyComp)
           {
            to << "\n\n" << "Hilbert poly :";
            for (i=0; i<dim; ++i)
               if (hden[i] == 1)
                  to << "   " << hnum[i];
               else
                  to << "   " << hnum[i] << "/" << hden[i];
           }
           else to << "\n\nHilbert polynomial not computed by normaliz since rank > 13, use enormalz\n\n";

         }
      }
      else
    to << "(original) semigroup is not homogeneous\n"; // wj {}
   }

                                                // polytopal case
   else if (mode == 2)
   {
      if (! vopt)
      {
         elimlist (newsol, &elimsol, &ifrei, olddim);
         genwid = 2 + maxoptlen (newsol, olddim);
         to << ilength (newsol) << " generators of Ehrhart ring: \n";
         for (idum=newsol; idum; idum=idum->right)
         {
            for (j=1; j<=olddim; ++j)
            {
               // to.width (genwid);
               for (ii=0; ii<genwid-optlen(idum->ind[j]); ++ii)
                  to << " ";
               to << idum->ind[j];
            }
            to << '\n';
         }
         to << '\n';

         genwid = 2 + maxoptlen (elimsol, olddim - 1);
         to << ilength (elimsol) << " lattice points in polytope: \n";
         for (idum=elimsol; idum; idum=idum->right)
         {
            for (j=1; j<olddim; ++j)
            {
               // to.width (genwid);
               for (ii=0; ii<genwid-optlen(idum->ind[j]); ++ii)
                  to << " ";
               to << idum->ind[j];
            }
            to << '\n';
         }
         to << '\n';

     to << numext << " extreme points of polytope: \n"; // wj {
     for (i=1; i<=numext; ++i)
       {
         for (j=1; j<olddim; ++j)
           {
         for (ii=0; ii<genwid-optlen(help1[i][j]); ++ii)
           to << ' ';
         to << help1[i][j];
           }
         to << '\n';
       }
     to << '\n'; // wj }

      }
      if (olddim == dim)
      {
         for (idum=newsup; idum; idum=idum->right)
            idum->ind[olddim] *= -1;
         supwid = 2 + maxoptlen (newsup, olddim);
         to << ilength (newsup) << " support hyperplanes: \n";
         for (idum=newsup; idum; idum=idum->right)
         {
            for (j=1; j<olddim; ++j)
            {
               // to.width (supwid);
               for (ii=0; ii<supwid-optlen(idum->ind[j]); ++ii)
                  to << " ";
               to << idum->ind[j];
            }
            // to.width (4);
            to << "   >=";
            // to.width (supwid);
            for (ii=0; ii<supwid-optlen(idum->ind[j]); ++ii)
               to << " ";
            to << idum->ind[j] << '\n';
         }
      }
      else
         to << "polytope is not of full dimension" << '\n';
      to << '\n' << "normalized volume = " << mty;   // will be homogeneous
      if (hopt)
      {
         to << "\n\n" << "h-vector =";
         for (i=0; i<dim; ++i)
            to << "   " << hvec[i];
       if(HilbPolyComp)
       {
         to << "\n\n" << "Ehrhart poly :";
         for (i=0; i<dim; ++i)
            if (hden[i] == 1)
               to << "   " << hnum[i];
            else
               to << "   " << hnum[i] << "/" << hden[i];
       }
       else to << "\n\nEhrhart polynomial not computed by normaliz since dim > 12, use enormalz\n\n";
      }
   }

                                          // Rees application
   else if (mode == 3)
   {
      if (! vopt)
      {
         elimlist (newsol, &elimsol, &ifrei, olddim);
         genwid = 2 + maxoptlen (newsol, olddim);
         to << ilength (newsol) << " generators of integral closure of Rees algebra: \n";
         for (idum=newsol; idum; idum=idum->right)
         {
            for (j=1; j<=olddim; ++j)
            {
               // to.width (genwid);
               for (ii=0; ii<genwid-optlen(idum->ind[j]); ++ii)
                  to << " ";
               to << idum->ind[j];
            }
            to << '\n';
         }
         to << '\n';

     to << numext << " extreme rays: \n"; // wj {
     for (i=1; i<=numext; ++i)
       {
         for (j=1; j<=olddim; ++j)
           {
         for (ii=0; ii<genwid-optlen(help1[i][j]); ++ii)
           to << ' ';
         to << help1[i][j];
           }
         to << '\n';
       }
     to << '\n'; // wj }

         genwid = 2 + maxoptlen (elimsol, olddim - 1);
         to << ilength (elimsol) << " generators of integral closure of the ideal: \n";
         for (idum=elimsol; idum; idum=idum->right)
         {
            for (j=1; j<olddim; ++j)
            {
               // to.width (genwid);
               for (ii=0; ii<genwid-optlen(idum->ind[j]); ++ii)
                  to << " ";
               to << idum->ind[j];
            }
            to << '\n';
         }
         to << '\n';
      }
      supwid = 2 + maxoptlen (newsup, olddim);
      to << ilength (newsup) << " support hyperplanes: \n";
      for (idum=newsup; idum; idum=idum->right)
      {
         for (j=1; j<=olddim; ++j)
         {
            // to.width (supwid);
            for (ii=0; ii<supwid-optlen(idum->ind[j]); ++ii)
               to << " ";
            to << idum->ind[j];
         }
         to << '\n';
      }
      to << '\n';
      if (hom)
      {
         to << "semigroup is homogeneous via the linear form \n";
         for (j=1; j<=olddim; ++j)
            to << "   " << invtraflf[1][j];
         to << "\n\n";
         to << "multiplicity = " << mty << '\n';
         if (hopt)
         {
            to << '\n' << "h-vector =";
            for (i=0; i<dim; ++i)
               to << "   " << hvec[i];
         if(HilbPolyComp)
         {
            to << "\n\n" << "Hilbert poly :";
            for (i=0; i<dim; ++i)
               if (hden[i] == 1)
                  to << "   " << hnum[i];
               else
                  to << "   " << hnum[i] << "/" << hden[i];
         }
         else to << "\n\nHilbert polynomial not computed by normaliz since rank > 13, use enormalz\n\n";

         }
      }
      else
    to << "semigroup is not homogeneous\n"; // wj {

      if (prim)
    {
          to << "\n\nideal is primary to the ideal generated by the indeterminates\n";
      to << "\nmultiplicity of the ideal = " << primmult << "\n";
        }
      else
        to << "\nideal is not primary to the ideal generated by the indeterminates\n";

      // wj }
   }

   to.close ();

   if(fopt)
  {
   strcpy (output, fname); // wj {
   strcat (output, ".inv");                    // to .inv
   ofstream itto (output);
   if (! to)
      wrterr ();

   itto << "num_invs=list(list(\"rank of semigroup\"," << dim  << ")";
   if (! emb)
       itto << ",list(\"index in integral closure\"," << idx << ")";
   if (hom)
     {
       itto << ",list(\"homogeneous w.r.t. weights\",\"" << invtraflf[1][1];
       for (j=2; j<=olddim; ++j)
     itto << "," << invtraflf[1][j];
       itto << "\"),list(\"multiplicity\"," << mty << ")";
       if(prim)
           itto << ",list(\"multiplicity of the ideal\"," << primmult << ")";
       if (hopt)
     {
       itto << ",list(\"h-vector\",\"" << hvec[0];
       for (i=1; i<dim; ++i)
         itto << "," << hvec[i];
       itto << "\")";
       if(HilbPolyComp)
       {
           Int fac = prod(1, dim-1);
       itto << ",list(\"Hilbert poly (multiplied by (r-1)!)\",\"" << (fac / hden[0]) * hnum[0];
       for (i=1; i<dim; ++i)
         itto << "," << (fac / hden[i]) * hnum[i];
           itto << "\")";
       }
     }
     }

   itto << ");\n";
   itto.close ();
  }

  /* if (vopt)                             // write volume to stderr -- NO LONGER
      cerr << mty << '\n';

   time = Cpu_time_counter(); // wj {     // Removed WB
   time1 += (time-lasttime);
   lasttime = time;

      printf("%d\n", time1);
      printf("%d\n", time2);
      printf("%d\n", stat1);
      printf("%d\n", stat2); // wj }*/
}
