/*
 * Copyright (c) 1998-2006 by Winfried Bruns and Robert Koch
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <iostream>
#include <fstream.h>
#include <iomanip.h>
// #include <libc.h>
#include <limits.h>

#ifndef LONG_BIT
short LONG_BIT;
#endif

typedef unsigned long ul;
typedef struct ilist {Int *ind; int len; ul set; int mark; ilist *left; ilist *right; ilist *leftreset; ilist *rightreset;} il;
typedef struct plist {ul *bitv; int *ind; int len; ul set; plist *left; plist *right; int hsets;} pl;

int main (int, char **);

void cmderr (void);
void readerr (void);
void dataerr (void);
void memerr (void);
void biterr (void);
void biterr2 (void);
void conerr (void);
void wrterr (void);
void isterr (void);
void moderr (void);
void interr (void);

Int traf (Int **, int, int *, Int **, Int **, Int **, int, Int **);
void retraf (il **, Int **, int, int, il **);
void retraflf (il **, Int **, int, int, il **, int);
void locpiv (Int **, int, int, int *, int *);
void chgrow (Int **, int, int, int);
void Chgrow (Int **, Int **, int, int, int);
void chgcol (Int **, int, int, int);
void redrow (Int **, int, int, int);
void Redrow (Int **, Int **, int, int, int);
void redcol (Int **, int, int, int, int);

void multmat (Int **, int, int, Int **, int, Int **);
void multlist (il **, Int **, int, int, il **);
void multvmv (Int *, int, Int **, int, Int *);
void scalmult (Int, Int *, int);
void scalmultmod (Int, Int *, Int, int);
void scaldiv (Int, Int *, int);
void addvecs (Int *, Int *, Int *, int);
void cpvec (Int *, Int *, int);
void redmod (Int *, Int, int);

void suphyp (Int **, int, int, il **, int, int *);
void addhyp (il **, il **, int, int, int, int *);
Int scprod (Int *, Int *, int);
#ifndef INTEGER
   int min (int, int);
   int max (int, int);
#endif
Int Lmin (Int, Int);
Int Lmax (Int, Int);
Int Labs (Int);

Int ggT (Int, Int);
Int Lcm (Int, Int);
void shorten (Int **, int, int);
void shlist (il *, int);
int optlen (Int);
int maxoptlen (il *, int);
int ilength (il *);
int plength (pl *);

void reduce (il **, Int *, int, il *, il **, Int *, int);
int incone (il *, Int *, int);
int wincone (il *, Int *);
int samevec (Int *, Int *, int);
void elimlist (il *, il **, il **, int);

int rank (Int **, int, int);
void diag (Int **, Int **, int);
int ishom (Int **, int, int, Int **, Int **, Int **);
int homtraf (Int **, int, int);

void setsig (pl **, int *, Int **, int, pl **, int *, int *, pl **, Int **);
void addsig (pl **, int *, Int **, int, int, il **, pl **, int *, int *, pl **, Int **, int *, int);
void sortvec (int *, int);
void lastsortvec (int *, int);
void ctrlcone (il **, Int **, int);

Int divisors (Int **, int, Int **, Int **, Int *);
void points (Int**, Int *, Int **, Int *, Int *, int, Int, il **, il *, il **, il *, int **, int, int);
void count (Int**, Int*, Int**, Int*, Int*, int, int, Int, il **, il *, il **, il *, int **, int, int, int, int *, int *, int *);
void nextpt (Int **, Int *, Int **, Int *, int, Int, il **, il *, il **, il *, int **, int, int, int, int *, int *, int *);

ul zerone (Int *, int);
void wrthmat (il *, int **, ul, Int, int, int, int *, int *, int *);
int subset (ul, ul);
int Subset (ul *, ul *, int);
void bitset (ul *, int);
void sumhvec (int **, int *, int);
void shift (int *, int, int);
void addvc (int *, int *, int);
void setup (il **, il **, int **, int *, il **, int);
long power (int, int);
int cntone (ul);
void reset (il **, il **, il **);
void mark (int, int, il **, il **, il **, int, int, pl *, pl *);
void subblocks (pl **, pl **, int *, int, int *, int *);
int onenewpoint (int *, int, int *, int, int *);
void findverts (int *, int, int *, int, pl *, int, int *, int *, int *, int *);
void punion (int *, int *, int *, int *);
int inplist (ul, int, int, pl *, pl *);
int inptlist (int *, int, pl *, int);
int inpplist (int *, int *, int);
void collsubsets (il *, int, il **);
void collsupsets (il *, int, il **);
void marksubsets (il *);
void collmarksupsets (il *, int, il **, il **);
void delsubsets (il *, il **);
int supset (ul, ul);

void hilbpoly (int *, Int *, Int *, Int *, Int **, int);
Int prod (int, int);
int parity (int);
void setevec (int *, Int *, int, Int *);
void diff (Int *, int);
void setpoly (Int **, int);
void sscalmult (Int, Int *, int);
void addvtv (Int *, Int *, int);
void simcanc (Int *, Int *, int);

void iisert (il **, il **, int);
void idlete (il **, il **);
void iidlete (il **, il **);
void icatchn (il **, il **);
void icatchnx (il **, il **);
void idelchn (il **, il **);
void ikilchn (il **);
void pisert (pl **, pl **, int);
void pdlete (pl **, pl **);
void pcatchn (pl **, pl **);
void pdelchn (pl **, pl **);
void pkilchn (pl **);

// wj {

int stat1=0,stat2=0;

#ifdef _Integer_h

int max(int a, int b) { return a>b ? a : b; }
int min(int a, int b) { return a<b ? a : b; }

#endif            // wj }

#include "alloc.c"
#include "elemdiv.c"
#include "error.c"
#include "homog.c"
#include "invest.c"
#include "linequ.c"
#include "reduce.c"
#include "shorten.c"
#include "sigma.c"
#include "heap.c"
#include "hilbert.c"
