/*
 * Copyright (c) 1998-2006 by Winfried Bruns and Robert Koch
 */

// wie in elemdiv.c
int rank (Int **a, int m, int n)
{
    int d, mn, r, s, i, j;
    int ne=n, nz=n, en=m, zn=m, dn=m;

    mn = min (m, n);
    for (d=0; d<mn; ++d)
    {
        locpiv (a, en, ne, &r, &s);
        if (r)
        {
            do
            {
                chgrow (a, en, nz, r);
                chgcol (a, ne, dn, s);
                redrow (a, ne, nz, en);
                redcol (a, ne, en, zn, dn);
                locpiv (a, en, ne, &r, &s);
            }
            while (r < en || s < ne);
            --ne;
            --en;
        }
        else
            break;
    }
    return (d);
}

void diag (Int **mat, Int **traf, int dim)
{
    int d, i, j, r, s;

    d = dim;
    while (d > 1)
    {
        locpiv (mat, d, d, &r, &s);
        do
        {
            Chgrow (mat, traf, d, dim, r);
            chgcol (mat, d, d, s);
            Redrow (mat, traf, d, dim, d);
            redcol (mat, d, d, d, d);
            locpiv (mat, d, d, &r, &s);
        }
        while (r < d || s < d);
        --d;
    }
}

int ishom (Int **a, int m, int n, Int **invtraf, Int **invtraflf, Int **newgen)
{
    int i, j, k, rk;
    int dn=m+2*n;

    for (i=1; i<m; ++i)
        for (j=1; j<=n; ++j)
        {
            invtraf[i][j] = a[i][j];
            a[i][j] -= a[m][j];
        }
    for (j=1; j<=n; ++j)
        invtraf[i][j] = a[i][j];
    rk = homtraf (a, m, n);
    if (rk == n  ||  Labs (a[m][1]) != 1)
        return (0);
    else
    {
        if (a[m][1] < 0)
            for (i=1; i<=dn; ++i)
                a[i][1] *= -1;
        for (i=1; i<=m; ++i)                                    // find newgen
            for (j=1; j<=n; ++j)
            {
                newgen[i][j] = 0;
                for (k=1; k<=n; ++k)
                    newgen[i][j] += invtraf[i][k] * a[k+m][j];
            }
        for (i=1; i<=n; ++i)                                // find invtraf's
            for (j=1; j<=n; ++j)
            {
                invtraf[j][i] = a[i+m+n][j];
                invtraflf[j][i] = a[i+m][j];
            }
        return (1);
    }
}

int homtraf (Int **a, int en, int ne)
{
    int d, i, j, mn, r, s;
    int nz=ne, zn=en+ne, dn=en+2*ne;

    for (i=en+1; i<=zn; ++i)
    {
        for (j=1; j<=ne; ++j)
            a[i][j] = a[i+ne][j] = 0;
        a[i][i-en] = a[i+ne][i-en] = 1;
    }
    --en;
    mn = min (en, ne);
    for (d=0; d<mn; ++d)
    {
        locpiv (a, en, ne, &r, &s);
        if (r)
        {
            do
            {
                chgrow (a, en, nz, r);
                chgcol (a, ne, dn, s);
                redrow (a, ne, nz, en);
                redcol (a, ne, en, zn, dn);
                locpiv (a, en, ne, &r, &s);
            }
            while (r < en  ||  s < ne);
            --ne;
            --en;
        }
        else
            break;
    }
    return (d);
}
