/*
 * Copyright (c) 1998-2006 by Winfried Bruns and Robert Koch
 */

void suphyp (Int **gen, int m, int n, il **sup, int tot, int *van)
{
    int dim=n, d, e, i, j, k, l, N=m+n, s;
    il *dum=NULL, *frei=NULL, *presup=NULL, *hps=NULL;

    shorten (gen, m, n);
    for (i=1; i<=n; ++i)
    {
        iisert (&presup, &frei, tot+1);
        for (j=1; j<=n; ++j)
            presup->ind[j] = 0;
        presup->ind[i] = 1;
    }
    for (d=n+1; d<=N; ++d)
    {
        for (dum=presup; dum; dum=dum->right)
            dum->ind[d] = scprod (gen[d-n], dum->ind, dim);
        for (dum=*sup; dum; dum=dum->right)
            dum->ind[d] = scprod (gen[d-n], dum->ind, dim);
        for (hps=presup; hps; hps=hps->right)
            if (hps->ind[d] != 0)
                break;
        if (! hps)                                                  // 1. Fall
            addhyp (sup, &frei, dim, d, tot, van);
        else                                                        // 2. Fall
        {
            for (dum=hps->left; dum; dum=dum->left)
            {
                dum->ind[0] = dum->ind[d];
                for (l=1; l<=d; ++l)
                    dum->ind[l] = dum->ind[l] * hps->ind[d] - dum->ind[0] * hps->ind[l];
            }
            for (dum=hps->right; dum; dum=dum->right)
            {
                dum->ind[0] = dum->ind[d];
                for (l=1; l<=d; ++l)
                    dum->ind[l] = dum->ind[l] * hps->ind[d] - dum->ind[0] * hps->ind[l];
            }
            if (hps->ind[d] < 0)
                for (j=1; j<=d; ++j)
                    hps->ind[j] *= -1;
            for (dum=*sup; dum; dum=dum->right)
            {
                dum->ind[0] = dum->ind[d];
                for (l=1; l<=d; ++l)
                    dum->ind[l] = dum->ind[l] * hps->ind[d] - dum->ind[0] * hps->ind[l];
            }
            iisert (sup, &frei, tot+1);
            for (j=1; j<=d; ++j)
                (*sup)->ind[j] = hps->ind[j];
            if (presup == hps)
                presup = presup->right;
            idlete (&hps, &frei);
        }
        shlist (presup, d);
        shlist (*sup, d);
    }
    idelchn (&presup, &frei);
    ikilchn (&frei);
    shlist (*sup, n);
}

void addhyp (il **sup, il **frei, int dim, int d, int tot, int *van)
{
    int e, i, j, k, l, s;
    il *dum, *pos=NULL, *neg=NULL, *nul=NULL, *hpos=NULL, *hneg=NULL;

    while (*sup)
    {
        if ((*sup)->ind[d] > 0)
            iisert (&pos, sup, -1);
        else if ((*sup)->ind[d] < 0)
            iisert (&neg, sup, -1);
        else
            iisert (&nul, sup, -1);
    }
    for (hpos=pos; hpos; hpos=hpos->right)
        for (hneg=neg; hneg; hneg=hneg->right)
        {
            van[0] = 0;
            for (e=dim+1; e<d; ++e)
                if (hpos->ind[e] == 0 && hneg->ind[e] == 0)
                {
                    ++van[0];
                    van[van[0]] = e;
                }
            s = 0;
            for (dum=hpos->left; dum; dum=dum->left)
            {
                for (e=1; e<=van[0]; ++e)
                    if (dum->ind[van[e]] != 0)
                        break;
                if (e > van[0])
                {
                    s = 1;
                    break;
                }
            }
            if (s)
                continue;
            for (dum=hpos->right; dum; dum=dum->right)
            {
                for (e=1; e<=van[0]; ++e)
                    if (dum->ind[van[e]] != 0)
                        break;
                if (e > van[0])
                {
                    s = 1;
                    break;
                        }
            }
            if (s)
                continue;
            for (dum=hneg->left; dum; dum=dum->left)
            {
                for (e=1; e<=van[0]; ++e)
                    if (dum->ind[van[e]] != 0)
                        break;
                if (e > van[0])
                {
                    s = 1;
                    break;
                }
            }
            if (s)
                continue;
            for (dum=hneg->right; dum; dum=dum->right)
            {
                for (e=1; e<=van[0]; ++e)
                    if (dum->ind[van[e]] != 0)
                        break;
                if (e > van[0])
                {
                    s = 1;
                    break;
                }
            }
            if (s)
                continue;
            for (dum=nul; dum; dum=dum->right)
            {
                for (e=1; e<=van[0]; ++e)
                    if (dum->ind[van[e]] != 0)
                        break;
                if (e > van[0])
                {
                    s = 1;
                    break;
                }
            }
            if (!s)
            {
                iisert (sup, frei, tot+1);
                for (k=1; k<=d; ++k)
                    (*sup)->ind[k] = hpos->ind[d] * hneg->ind[k] - hneg->ind[d] * hpos->ind[k];
            }
        }
    icatchn (sup, &pos);
    icatchn (sup, &nul);
    idelchn (&neg, frei);
    shlist (*sup, d);
}

Int scprod (Int *a, Int *b, int c)
{
    int i;
    Int s;

    s = 0;
    for (i=1; i<=c; ++i)
        s += a[i] * b[i];
    return (s);
}

#ifndef INTEGER

int min (int a, int b)
{
    if (a < b)
        return (a);
    return (b);
}

int max (int a, int b)
{
    if (a > b)
        return (a);
    return (b);
}

#endif

Int Lmin (Int a, Int b)
{
    if (a < b)
        return (a);
    return (b);
}

Int Lmax (Int a, Int b)
{
    if (a < b)
        return (b);
    return (a);
}

Int Labs (Int a)
{
    if (a >= 0)
        return (a);
    return (-a);
}
