/*
 * Copyright (c) 1998-2006 by Winfried Bruns and Robert Koch
 */

void reduce (il **sol, Int *y, int dim, il *sup, il **frei, Int *vec, int mode)
{
    int flag, i, j=1;
    il *dum;

    while (j <= dim  &&  y[j] == 0)
        ++j;
    if (j <= dim)                                               // y != 0 column
        {
            for (dum=*sol; dum; dum=dum->right)
            {
                for (j=1; j<=dim; ++j)
                    vec[j] = y[j] - dum->ind[j];
                if (incone (sup, vec, dim))
                    break;
            }
            if (! dum)                                      // all not in cone
            {
                for (dum=*sol; dum;)
                {
                    for (j=1; j<=dim; ++j)
                        vec[j] = dum->ind[j] - y[j];
                    flag = 1;
                    if (incone (sup, vec, dim))
                    {
                        if (dum == *sol)
                            *sol = (*sol)->right;
                        idlete (&dum, frei);
                        flag = 0;
                    }
                    if (flag)
                        dum=dum->right;
                }
                iisert (sol, frei, dim+1);
                for (j=1; j<=dim; ++j)
                    (*sol)->ind[j] = y[j];
            }
        }
}

int incone (il *sup, Int *vec, int dim)
{
    int i, j;
    Int z;

    for (; sup; sup=sup->right)
    {
        z = 0;
        for (j=1; j<=dim; ++j)
            z += sup->ind[j] * vec[j];
        if (z < 0)
            return (0);
    }
    return (1);
}

int wincone (il *sup, Int *vec)
{
    int h=0, i, j;
    Int z;

    for (; sup; sup=sup->right)
    {
        z = 0;
        for (j=1; j<=vec[0]; ++j)
            z += sup->ind[j] * vec[j];
        if (z < 0)
            return (0);                                     // not in cone
        else if (z == 0)
            h = 1;
    }
    if (h)
        return (1);                                         // on a facet
    return (2);                                         // interior point
}

int samevec (Int *a, Int *b, int len)
{
    int i;

    for (i=1; i<=len; ++i)
        if (a[i] != b[i])
            return (0);
    return (1);
}

void elimlist (il *full, il **part, il **frei, int len)
{
    il *dum;

    for (dum=full; dum->right; dum=dum->right)
        ;
    for (; dum; dum=dum->left)
        if (dum->ind[len] == 1)
        {
            iisert (part, frei, 1);
            (*part)->ind = dum->ind;
        }
}
