/*
 * Copyright (c) 1998-2006 by Winfried Bruns and Robert Koch
 */

Int ggT (Int a, Int b)
{
  Int c;

  if (a == 0)
    return (b);
  if (b == 0)
    return (a);
  while ((c = a % b) != 0)
  {
    a = b;
    b = c;
  }
  return (b);
}

Int Lcm (Int a, Int b)
{
  return ((a * b) / ggT (a, b));
}

/*
** If a whole row is divisible to some integer g,
** shorten the row by dividing
*/
void shorten (Int **a, int m, int n)
{
  int i, j;
  Int g;

  for (i=1; i<=m; ++i)
  {
    g = a[i][1];
    for (j=2; j<=n; ++j)
      g = ggT (g, a[i][j]);
    g = Labs (g);
    if (g != 0)
      for (j=1; j<=n; ++j)
        a[i][j] /= g;
  }
}

/*
** Wie oben, allerdings mit anderer Datenstruktur
*/
void shlist (il *a, int n)
{
  int i, j;
  Int g;

  for (; a; a=a->right)
  {
    g = a->ind[1];
    for (j=2; j<=n; ++j)
      g = ggT (g, a->ind[j]);
    g = Labs (g);
    for (j=1; j<=n; ++j)
      a->ind[j] /= g;
  }
}

int optlen (Int a)
{
  int l=1;

  if (a < 0)
  {
    a = -a;
    ++l;
  }
  while ((a /= 10) != 0)
    ++l;
  return (l);
}

int maxoptlen (il *a, int dim)
{
  int i, ll=0;

  for (; a; a=a->right)
    for (i=1; i<=dim; ++i)
      ll = max (ll, optlen (a->ind[i]));
  return (ll);
}

int ilength (il *a)
{
  int l=0;

  for (; a; a=a->right)
    ++l;
  return (l);
}

int plength (pl *a)
{
  int l=0;

  for (; a; a=a->right)
    ++l;
  return (l);
}
