/*
 * Copyright (c) 1998-2006 by Winfried Bruns and Robert Koch
 */

/*
** Auch hier wieder: die insig[0], ninsig[0] Werte sind nur temp. Werte
*/
void setsig (pl **blstart, int *numbl, Int **gen, int dim, pl **sig, int *insig, int *ninsig, pl **frei, Int **a)
{
    int rk, i, j, k;
    int nc = ninsig[0];

    //cout << "SETSIG LowLeveling" << endl;

    for (rk=1; rk<=dim; ++rk)
    {
        for (i=ninsig[0]; i>0; --i)         // initial ninsig[0] = nc, ninsig[1] = nc, ninsig[2] = nc-1, ...
        {
            for (k=1; k<=insig[0]; ++k)
                for (j=1; j<=dim; ++j)
                    a[k][j] = gen[insig[k]][j]; // a ist nur Hilfsmatrix (mit Mll gefllt!!), gen die ggf. angepassten Erzeuger
                                                // insig initial leer, insig[0] = 0

            for (j=1; j<=dim; ++j)              // a wird durch obige Schleifen bei jeder i-Iteration neu mit den insigs aufgebaut
                a[k][j] = gen[ninsig[i]][j];    // und hier ein "frischer" Erzeuger zum Rang-Test hinzugenommen

            /*getchar();
            print_amatrix(a,k,dim,"a sig");*/

            if (rank (a, k, dim) == rk)
            {
                ++insig[0];                     // einen ins Sigma aufnehmen
                insig[insig[0]] = ninsig[i];    // an Stelle insig[0] den speichern, den ich aufgenommen habe
                for (j=i; j<ninsig[0]; ++j)
                    ninsig[j] = ninsig[j+1];
                --ninsig[0];
                break;
            }                   // bis hierhin: Suche nach dim vielen lin. unabh. newgens ?
        }
    }

    pisert (sig, frei, dim+1);      // Start-Triangulierung einsetzen, sig und frei beide NULL am Anfang
    for (i=1; i<=insig[0]; ++i)
        (*sig)->ind[i] = insig[i];  // oben gewonnene Indizierung eintragen
    *numbl = 1;
    blstart[1] = *sig;

    #ifdef CHECKOUT
        print_alist1(sig,dim+1,"Liste sig in setsig am Ende");
    #endif
}

void addsig (pl **blstart, int *numbl, Int **gen, int nc, int dim, il **sup, pl **sig, int *insig, int *ninsig, pl **frei, Int **b, int *zer, int copt)
{
    int cur, tot=dim+nc, h, i, j, k, l, z, ok;
    il *eum=NULL, *flist=NULL;
    pl *dum=NULL, *ent=NULL;

    for (i=1; i<=dim; ++i)                  // die dim vielen Gens
        for (j=1; j<=dim; ++j)              // aus der 1. Triangulierung holen
            b[i][j] = gen[insig[i]][j];     // b wieder Hilfsmatrix, ggf. mit Mll gefllt...

    #ifdef CHEqqqqqqqqqqqqqCKOUT
        print_amatrix(b,dim,dim,"Matrix \'b\' in addsig, erste Triag.");
    #endif

    suphyp (b, dim, dim, sup, tot, zer);    // support hyp. of C_0

    #ifdef CHECqqqqqqqqqqqqqqqKOUT
        print_alist(sup,dim,"Liste sup in addsig nach suphyp()");
    #endif

    cur = 2 * dim + 1;
    while (ninsig[0])
    {
        ok = 0;
        ent = *sig;
        for (eum=*sup; eum; eum=eum->right)
            if ((eum->ind[cur] = scprod(gen[ninsig[ninsig[0]]], eum->ind, dim)) < 0)
            {
                zer[0] = 0;
                for (j=dim+1; j<cur; ++j)
                    if (eum->ind[j] == 0)
                    {
                        ++zer[0];
                        zer[zer[0]] = j - dim;
                    }
                if (zer[0] == dim-1)                            // 1. Fall
                {
                    ok = 1;
                    pisert (sig, frei, dim+1);
                    for (j=1; j<dim; ++j)
                        (*sig)->ind[j] = insig[zer[j]];
                    (*sig)->ind[j] = ninsig[ninsig[0]];         // neu in [dim]
                    sortvec ((*sig)->ind, dim-1);
                }
                else                                            // 2. Fall
                    for (dum=ent; dum; dum=dum->right)          // \sigma[j]
                    {
                        zer[0] = 0;
                        for (k=1; k<=dim; ++k)                  // \sigma[j][k]
                            if (scprod (gen[dum->ind[k]], eum->ind, dim) == 0)
                            {
                                ++zer[0];
                                zer[zer[0]] = k;
                            }
                        if (zer[0] == dim-1)
                        {
                            ok = 1;
                            pisert (sig, frei, dim+1);
                            for (k=1; k<dim; ++k)
                                (*sig)->ind[k] = dum->ind[zer[k]];
                            (*sig)->ind[k] = ninsig[ninsig[0]]; // neu in [dim]
                            lastsortvec ((*sig)->ind, dim-1);
                        }
                    }
            }
        ++insig[0];
        if(copt) fprintf (stdout, "Done with generator %d \n", insig[0]);
        insig[insig[0]] = ninsig[ninsig[0]];
        --ninsig[0];
        if (ok)
        {
            ++(*numbl);
            blstart[*numbl] = *sig;
        }
        addhyp (sup, &flist, dim, cur, tot, zer);
        ++cur;
    }
    ikilchn (&flist);
}

void sortvec (int *vec, int len)
{
    int i;

    for (i=2; i<=len; ++i)
        lastsortvec (vec, i);
}

void lastsortvec (int *vec, int len)
{
    int ch;

    while (len > 1  &&  vec[len] <= vec[len-1])
    {
        ch = vec[len];
        vec[len] = vec[len-1];
        --len;
        vec[len] = ch;
    }
}

void ctrlcone (il **sup, Int **a, int dim)
{
    int rk, i, j, k, suc=0;
    il *ins=NULL, *dum=*sup, *eum;

    for (rk=1; rk<=dim; ++rk)
    {
        while (dum)
        {
            k = 0;
            for (eum=ins; eum; eum=eum->right)
            {
                ++k;
                for (j=1; j<=dim; ++j)
                    a[k][j] = eum->ind[j];
            }
            ++k;
            for (j=1; j<=dim; ++j)
                a[k][j] = dum->ind[j];
            if (rank (a, k, dim) == rk)
            {
                if (dum == *sup)
                    *sup = (*sup)->right;
                idlete (&dum, &ins);
                ++suc;
                break;
            }
            else
                dum = dum->right;
        }
    }
    if (suc < dim)
        conerr ();
    icatchn (sup, &ins);
}
